Update Gnulib to v0.0-5874-g7170ee0.
[bpt/guile.git] / maint.mk
1 # -*-Makefile-*-
2 # This Makefile fragment tries to be general-purpose enough to be
3 # used by many projects via the gnulib maintainer-makefile module.
4
5 ## Copyright (C) 2001-2011 Free Software Foundation, Inc.
6 ##
7 ## This program is free software: you can redistribute it and/or modify
8 ## it under the terms of the GNU General Public License as published by
9 ## the Free Software Foundation, either version 3 of the License, or
10 ## (at your option) any later version.
11 ##
12 ## This program is distributed in the hope that it will be useful,
13 ## but WITHOUT ANY WARRANTY; without even the implied warranty of
14 ## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
15 ## GNU General Public License for more details.
16 ##
17 ## You should have received a copy of the GNU General Public License
18 ## along with this program. If not, see <http://www.gnu.org/licenses/>.
19
20 # This is reported not to work with make-3.79.1
21 # ME := $(word $(words $(MAKEFILE_LIST)),$(MAKEFILE_LIST))
22 ME := maint.mk
23
24 # Override this in cfg.mk if you use a non-standard build-aux directory.
25 build_aux ?= $(srcdir)/build-aux
26
27 # Do not save the original name or timestamp in the .tar.gz file.
28 # Use --rsyncable if available.
29 gzip_rsyncable := \
30 $(shell gzip --help 2>/dev/null|grep rsyncable >/dev/null \
31 && printf %s --rsyncable)
32 GZIP_ENV = '--no-name --best $(gzip_rsyncable)'
33
34 GIT = git
35 VC = $(GIT)
36
37 VC_LIST = $(build_aux)/vc-list-files -C $(srcdir)
38
39 # You can override this variable in cfg.mk to set your own regexp
40 # matching files to ignore.
41 VC_LIST_ALWAYS_EXCLUDE_REGEX ?= ^$$
42
43 # This is to preprocess robustly the output of $(VC_LIST), so that even
44 # when $(srcdir) is a pathological name like "....", the leading sed command
45 # removes only the intended prefix.
46 _dot_escaped_srcdir = $(subst .,\.,$(srcdir))
47
48 # Post-process $(VC_LIST) output, prepending $(srcdir)/, but only
49 # when $(srcdir) is not ".".
50 ifeq ($(srcdir),.)
51 _prepend_srcdir_prefix =
52 else
53 _prepend_srcdir_prefix = | sed 's|^|$(srcdir)/|'
54 endif
55
56 # In order to be able to consistently filter "."-relative names,
57 # (i.e., with no $(srcdir) prefix), this definition is careful to
58 # remove any $(srcdir) prefix, and to restore what it removes.
59 _sc_excl = \
60 $(if $(exclude_file_name_regexp--$@),$(exclude_file_name_regexp--$@),^$$)
61 VC_LIST_EXCEPT = \
62 $(VC_LIST) | sed 's|^$(_dot_escaped_srcdir)/||' \
63 | if test -f $(srcdir)/.x-$@; then grep -vEf $(srcdir)/.x-$@; \
64 else grep -Ev -e "$${VC_LIST_EXCEPT_DEFAULT-ChangeLog}"; fi \
65 | grep -Ev -e '($(VC_LIST_ALWAYS_EXCLUDE_REGEX)|$(_sc_excl))' \
66 $(_prepend_srcdir_prefix)
67
68 ifeq ($(origin prev_version_file), undefined)
69 prev_version_file = $(srcdir)/.prev-version
70 endif
71
72 PREV_VERSION := $(shell cat $(prev_version_file) 2>/dev/null)
73 VERSION_REGEXP = $(subst .,\.,$(VERSION))
74 PREV_VERSION_REGEXP = $(subst .,\.,$(PREV_VERSION))
75
76 ifeq ($(VC),$(GIT))
77 this-vc-tag = v$(VERSION)
78 this-vc-tag-regexp = v$(VERSION_REGEXP)
79 else
80 tag-package = $(shell echo "$(PACKAGE)" | tr '[:lower:]' '[:upper:]')
81 tag-this-version = $(subst .,_,$(VERSION))
82 this-vc-tag = $(tag-package)-$(tag-this-version)
83 this-vc-tag-regexp = $(this-vc-tag)
84 endif
85 my_distdir = $(PACKAGE)-$(VERSION)
86
87 # Old releases are stored here.
88 release_archive_dir ?= ../release
89
90 # Override gnu_rel_host and url_dir_list in cfg.mk if these are not right.
91 # Use alpha.gnu.org for alpha and beta releases.
92 # Use ftp.gnu.org for stable releases.
93 gnu_ftp_host-alpha = alpha.gnu.org
94 gnu_ftp_host-beta = alpha.gnu.org
95 gnu_ftp_host-stable = ftp.gnu.org
96 gnu_rel_host ?= $(gnu_ftp_host-$(RELEASE_TYPE))
97
98 ifeq ($(gnu_rel_host),ftp.gnu.org)
99 url_dir_list ?= http://ftpmirror.gnu.org/$(PACKAGE)
100 else
101 url_dir_list ?= ftp://$(gnu_rel_host)/gnu/$(PACKAGE)
102 endif
103
104 # Override this in cfg.mk if you are using a different format in your
105 # NEWS file.
106 today = $(shell date +%Y-%m-%d)
107
108 # Select which lines of NEWS are searched for $(news-check-regexp).
109 # This is a sed line number spec. The default says that we search
110 # lines 1..10 of NEWS for $(news-check-regexp).
111 # If you want to search only line 3 or only lines 20-22, use "3" or "20,22".
112 news-check-lines-spec ?= 1,10
113 news-check-regexp ?= '^\*.* $(VERSION_REGEXP) \($(today)\)'
114
115 # Prevent programs like 'sort' from considering distinct strings to be equal.
116 # Doing it here saves us from having to set LC_ALL elsewhere in this file.
117 export LC_ALL = C
118
119 ## --------------- ##
120 ## Sanity checks. ##
121 ## --------------- ##
122
123 _cfg_mk := $(shell test -f $(srcdir)/cfg.mk && echo '$(srcdir)/cfg.mk')
124
125 # Collect the names of rules starting with `sc_'.
126 syntax-check-rules := $(sort $(shell sed -n 's/^\(sc_[a-zA-Z0-9_-]*\):.*/\1/p' \
127 $(srcdir)/$(ME) $(_cfg_mk)))
128 .PHONY: $(syntax-check-rules)
129
130 ifeq ($(shell $(VC_LIST) >/dev/null 2>&1; echo $$?),0)
131 local-checks-available += $(syntax-check-rules)
132 else
133 local-checks-available += no-vc-detected
134 no-vc-detected:
135 @echo "No version control files detected; skipping syntax check"
136 endif
137 .PHONY: $(local-checks-available)
138
139 # Arrange to print the name of each syntax-checking rule just before running it.
140 $(syntax-check-rules): %: %.m
141 sc_m_rules_ = $(patsubst %, %.m, $(syntax-check-rules))
142 .PHONY: $(sc_m_rules_)
143 $(sc_m_rules_):
144 @echo $(patsubst sc_%.m, %, $@)
145 @date +%s.%N > .sc-start-$(basename $@)
146
147 # Compute and print the elapsed time for each syntax-check rule.
148 sc_z_rules_ = $(patsubst %, %.z, $(syntax-check-rules))
149 .PHONY: $(sc_z_rules_)
150 $(sc_z_rules_): %.z: %
151 @end=$$(date +%s.%N); \
152 start=$$(cat .sc-start-$*); \
153 rm -f .sc-start-$*; \
154 awk -v s=$$start -v e=$$end \
155 'END {printf "%.2f $(patsubst sc_%,%,$*)\n", e - s}' < /dev/null
156
157 # The patsubst here is to replace each sc_% rule with its sc_%.z wrapper
158 # that computes and prints elapsed time.
159 local-check := \
160 $(patsubst sc_%, sc_%.z, \
161 $(filter-out $(local-checks-to-skip), $(local-checks-available)))
162
163 syntax-check: $(local-check)
164
165 # _sc_search_regexp
166 #
167 # This macro searches for a given construct in the selected files and
168 # then takes some action.
169 #
170 # Parameters (shell variables):
171 #
172 # prohibit | require
173 #
174 # Regular expression (ERE) denoting either a forbidden construct
175 # or a required construct. Those arguments are exclusive.
176 #
177 # in_vc_files | in_files
178 #
179 # grep-E-style regexp denoting the files to check. If no files
180 # are specified the default are all the files that are under
181 # version control.
182 #
183 # containing | non_containing
184 #
185 # Select the files (non) containing strings matching this regexp.
186 # If both arguments are specified then CONTAINING takes
187 # precedence.
188 #
189 # with_grep_options
190 #
191 # Extra options for grep.
192 #
193 # ignore_case
194 #
195 # Ignore case.
196 #
197 # halt
198 #
199 # Message to display before to halting execution.
200 #
201 # Finally, you may exempt files based on an ERE matching file names.
202 # For example, to exempt from the sc_space_tab check all files with the
203 # .diff suffix, set this Make variable:
204 #
205 # exclude_file_name_regexp--sc_space_tab = \.diff$
206 #
207 # Note that while this functionality is mostly inherited via VC_LIST_EXCEPT,
208 # when filtering by name via in_files, we explicitly filter out matching
209 # names here as well.
210
211 # By default, _sc_search_regexp does not ignore case.
212 export ignore_case =
213 _ignore_case = $$(test -n "$$ignore_case" && printf %s -i || :)
214
215 define _sc_say_and_exit
216 dummy=; : so we do not need a semicolon before each use; \
217 { printf '%s\n' "$(ME): $$msg" 1>&2; exit 1; };
218 endef
219
220 # _sc_search_regexp used to be named _prohibit_regexp. However,
221 # upgrading to the new definition and leaving the old name undefined
222 # would usually convert each custom rule using $(_prohibit_regexp)
223 # (usually defined in cfg.mk) into a no-op. This definition ensures
224 # that people know right away if they're still using the old name.
225 # FIXME: remove in 2012.
226 _prohibit_regexp = \
227 $(error '*** you need to s/_prohibit_regexp/_sc_search_regexp/, and adapt')
228
229 define _sc_search_regexp
230 dummy=; : so we do not need a semicolon before each use; \
231 \
232 : Check arguments; \
233 test -n "$$prohibit" && test -n "$$require" \
234 && { msg='Cannot specify both prohibit and require' \
235 $(_sc_say_and_exit) } || :; \
236 test -z "$$prohibit" && test -z "$$require" \
237 && { msg='Should specify either prohibit or require' \
238 $(_sc_say_and_exit) } || :; \
239 test -n "$$in_vc_files" && test -n "$$in_files" \
240 && { msg='Cannot specify both in_vc_files and in_files' \
241 $(_sc_say_and_exit) } || :; \
242 test "x$$halt" != x \
243 || { msg='halt not defined' $(_sc_say_and_exit) }; \
244 \
245 : Filter by file name; \
246 if test -n "$$in_files"; then \
247 files=$$(find $(srcdir) | grep -E "$$in_files" \
248 | grep -Ev '$(exclude_file_name_regexp--$@)'); \
249 else \
250 files=$$($(VC_LIST_EXCEPT)); \
251 if test -n "$$in_vc_files"; then \
252 files=$$(echo "$$files" | grep -E "$$in_vc_files"); \
253 fi; \
254 fi; \
255 \
256 : Filter by content; \
257 test -n "$$files" && test -n "$$containing" \
258 && { files=$$(grep -l "$$containing" $$files); } || :; \
259 test -n "$$files" && test -n "$$non_containing" \
260 && { files=$$(grep -vl "$$non_containing" $$files); } || :; \
261 \
262 : Check for the construct; \
263 if test -n "$$files"; then \
264 if test -n "$$prohibit"; then \
265 grep $$with_grep_options $(_ignore_case) -nE "$$prohibit" $$files \
266 && { msg="$$halt" $(_sc_say_and_exit) } || :; \
267 else \
268 grep $$with_grep_options $(_ignore_case) -LE "$$require" $$files \
269 | grep . \
270 && { msg="$$halt" $(_sc_say_and_exit) } || :; \
271 fi \
272 else :; \
273 fi || :;
274 endef
275
276 sc_avoid_if_before_free:
277 @$(build_aux)/useless-if-before-free \
278 $(useless_free_options) \
279 $$($(VC_LIST_EXCEPT) | grep -v useless-if-before-free) && \
280 { echo '$(ME): found useless "if" before "free" above' 1>&2; \
281 exit 1; } || :
282
283 sc_cast_of_argument_to_free:
284 @prohibit='\<free *\( *\(' halt='don'\''t cast free argument' \
285 $(_sc_search_regexp)
286
287 sc_cast_of_x_alloc_return_value:
288 @prohibit='\*\) *x(m|c|re)alloc\>' \
289 halt='don'\''t cast x*alloc return value' \
290 $(_sc_search_regexp)
291
292 sc_cast_of_alloca_return_value:
293 @prohibit='\*\) *alloca\>' \
294 halt='don'\''t cast alloca return value' \
295 $(_sc_search_regexp)
296
297 sc_space_tab:
298 @prohibit='[ ] ' \
299 halt='found SPACE-TAB sequence; remove the SPACE' \
300 $(_sc_search_regexp)
301
302 # Don't use *scanf or the old ato* functions in `real' code.
303 # They provide no error checking mechanism.
304 # Instead, use strto* functions.
305 sc_prohibit_atoi_atof:
306 @prohibit='\<([fs]?scanf|ato([filq]|ll)) *\(' \
307 halt='do not use *scan''f, ato''f, ato''i, ato''l, ato''ll or ato''q' \
308 $(_sc_search_regexp)
309
310 # Use STREQ rather than comparing strcmp == 0, or != 0.
311 sc_prohibit_strcmp:
312 @grep -nE '! *str''cmp *\(|\<str''cmp *\(.+\) *[!=]=' \
313 $$($(VC_LIST_EXCEPT)) \
314 | grep -vE ':# *define STRN?EQ\(' && \
315 { echo '$(ME): replace str''cmp calls above with STREQ/STRNEQ' \
316 1>&2; exit 1; } || :
317
318 # Pass EXIT_*, not number, to usage, exit, and error (when exiting)
319 # Convert all uses automatically, via these two commands:
320 # git grep -l '\<exit *(1)' \
321 # | grep -vEf .x-sc_prohibit_magic_number_exit \
322 # | xargs --no-run-if-empty \
323 # perl -pi -e 's/(^|[^.])\b(exit ?)\(1\)/$1$2(EXIT_FAILURE)/'
324 # git grep -l '\<exit *(0)' \
325 # | grep -vEf .x-sc_prohibit_magic_number_exit \
326 # | xargs --no-run-if-empty \
327 # perl -pi -e 's/(^|[^.])\b(exit ?)\(0\)/$1$2(EXIT_SUCCESS)/'
328 sc_prohibit_magic_number_exit:
329 @prohibit='(^|[^.])\<(usage|exit) ?\([0-9]|\<error ?\([1-9][0-9]*,' \
330 halt='use EXIT_* values rather than magic number' \
331 $(_sc_search_regexp)
332
333 # Using EXIT_SUCCESS as the first argument to error is misleading,
334 # since when that parameter is 0, error does not exit. Use `0' instead.
335 sc_error_exit_success:
336 @prohibit='error *\(EXIT_SUCCESS,' \
337 in_vc_files='\.[chly]$$' \
338 halt='found error (EXIT_SUCCESS' \
339 $(_sc_search_regexp)
340
341 # `FATAL:' should be fully upper-cased in error messages
342 # `WARNING:' should be fully upper-cased, or fully lower-cased
343 sc_error_message_warn_fatal:
344 @grep -nEA2 '[^rp]error *\(' $$($(VC_LIST_EXCEPT)) \
345 | grep -E '"Warning|"Fatal|"fatal' && \
346 { echo '$(ME): use FATAL, WARNING or warning' 1>&2; \
347 exit 1; } || :
348
349 # Error messages should not start with a capital letter
350 sc_error_message_uppercase:
351 @grep -nEA2 '[^rp]error *\(' $$($(VC_LIST_EXCEPT)) \
352 | grep -E '"[A-Z]' \
353 | grep -vE '"FATAL|"WARNING|"Java|"C#|PRIuMAX' && \
354 { echo '$(ME): found capitalized error message' 1>&2; \
355 exit 1; } || :
356
357 # Error messages should not end with a period
358 sc_error_message_period:
359 @grep -nEA2 '[^rp]error *\(' $$($(VC_LIST_EXCEPT)) \
360 | grep -E '[^."]\."' && \
361 { echo '$(ME): found error message ending in period' 1>&2; \
362 exit 1; } || :
363
364 sc_file_system:
365 @prohibit=file''system \
366 ignore_case=1 \
367 halt='found use of "file''system"; spell it "file system"' \
368 $(_sc_search_regexp)
369
370 # Don't use cpp tests of this symbol. All code assumes config.h is included.
371 sc_prohibit_have_config_h:
372 @prohibit='^# *if.*HAVE''_CONFIG_H' \
373 halt='found use of HAVE''_CONFIG_H; remove' \
374 $(_sc_search_regexp)
375
376 # Nearly all .c files must include <config.h>. However, we also permit this
377 # via inclusion of a package-specific header, if cfg.mk specified one.
378 # config_h_header must be suitable for grep -E.
379 config_h_header ?= <config\.h>
380 sc_require_config_h:
381 @require='^# *include $(config_h_header)' \
382 in_vc_files='\.c$$' \
383 halt='the above files do not include <config.h>' \
384 $(_sc_search_regexp)
385
386 # You must include <config.h> before including any other header file.
387 # This can possibly be via a package-specific header, if given by cfg.mk.
388 sc_require_config_h_first:
389 @if $(VC_LIST_EXCEPT) | grep -l '\.c$$' > /dev/null; then \
390 fail=0; \
391 for i in $$($(VC_LIST_EXCEPT) | grep '\.c$$'); do \
392 grep '^# *include\>' $$i | sed 1q \
393 | grep -E '^# *include $(config_h_header)' > /dev/null \
394 || { echo $$i; fail=1; }; \
395 done; \
396 test $$fail = 1 && \
397 { echo '$(ME): the above files include some other header' \
398 'before <config.h>' 1>&2; exit 1; } || :; \
399 else :; \
400 fi
401
402 sc_prohibit_HAVE_MBRTOWC:
403 @prohibit='\bHAVE_MBRTOWC\b' \
404 halt="do not use $$prohibit; it is always defined" \
405 $(_sc_search_regexp)
406
407 # To use this "command" macro, you must first define two shell variables:
408 # h: the header name, with no enclosing <> or ""
409 # re: a regular expression that matches IFF something provided by $h is used.
410 define _sc_header_without_use
411 dummy=; : so we do not need a semicolon before each use; \
412 h_esc=`echo '[<"]'"$$h"'[">]'|sed 's/\./\\\\./g'`; \
413 if $(VC_LIST_EXCEPT) | grep -l '\.c$$' > /dev/null; then \
414 files=$$(grep -l '^# *include '"$$h_esc" \
415 $$($(VC_LIST_EXCEPT) | grep '\.c$$')) && \
416 grep -LE "$$re" $$files | grep . && \
417 { echo "$(ME): the above files include $$h but don't use it" \
418 1>&2; exit 1; } || :; \
419 else :; \
420 fi
421 endef
422
423 # Prohibit the inclusion of assert.h without an actual use of assert.
424 sc_prohibit_assert_without_use:
425 @h='assert.h' re='\<assert *\(' $(_sc_header_without_use)
426
427 # Prohibit the inclusion of close-stream.h without an actual use.
428 sc_prohibit_close_stream_without_use:
429 @h='close-stream.h' re='\<close_stream *\(' $(_sc_header_without_use)
430
431 # Prohibit the inclusion of getopt.h without an actual use.
432 sc_prohibit_getopt_without_use:
433 @h='getopt.h' re='\<getopt(_long)? *\(' $(_sc_header_without_use)
434
435 # Don't include quotearg.h unless you use one of its functions.
436 sc_prohibit_quotearg_without_use:
437 @h='quotearg.h' re='\<quotearg(_[^ ]+)? *\(' $(_sc_header_without_use)
438
439 # Don't include quote.h unless you use one of its functions.
440 sc_prohibit_quote_without_use:
441 @h='quote.h' re='\<quote(_n)? *\(' $(_sc_header_without_use)
442
443 # Don't include this header unless you use one of its functions.
444 sc_prohibit_long_options_without_use:
445 @h='long-options.h' re='\<parse_long_options *\(' \
446 $(_sc_header_without_use)
447
448 # Don't include this header unless you use one of its functions.
449 sc_prohibit_inttostr_without_use:
450 @h='inttostr.h' re='\<(off|[iu]max|uint)tostr *\(' \
451 $(_sc_header_without_use)
452
453 # Don't include this header unless you use one of its functions.
454 sc_prohibit_ignore_value_without_use:
455 @h='ignore-value.h' re='\<ignore_(value|ptr) *\(' \
456 $(_sc_header_without_use)
457
458 # Don't include this header unless you use one of its functions.
459 sc_prohibit_error_without_use:
460 @h='error.h' \
461 re='\<error(_at_line|_print_progname|_one_per_line|_message_count)? *\('\
462 $(_sc_header_without_use)
463
464 # Don't include xalloc.h unless you use one of its functions.
465 # Consider these symbols:
466 # perl -lne '/^# *define (\w+)\(/ and print $1' lib/xalloc.h|grep -v '^__';
467 # perl -lne '/^(?:extern )?(?:void|char) \*?(\w+) *\(/ and print $1' lib/xalloc.h
468 # Divide into two sets on case, and filter each through this:
469 # | sort | perl -MRegexp::Assemble -le \
470 # 'print Regexp::Assemble->new(file => "/dev/stdin")->as_string'|sed 's/\?://g'
471 # Note this was produced by the above:
472 # _xa1 = \
473 #x(((2n?)?re|c(har)?|n(re|m)|z)alloc|alloc_(oversized|die)|m(alloc|emdup)|strdup)
474 # But we can do better, in at least two ways:
475 # 1) take advantage of two "dup"-suffixed strings:
476 # x(((2n?)?re|c(har)?|n(re|m)|[mz])alloc|alloc_(oversized|die)|(mem|str)dup)
477 # 2) notice that "c(har)?|[mz]" is equivalent to the shorter and more readable
478 # "char|[cmz]"
479 # x(((2n?)?re|char|n(re|m)|[cmz])alloc|alloc_(oversized|die)|(mem|str)dup)
480 _xa1 = x(((2n?)?re|char|n(re|m)|[cmz])alloc|alloc_(oversized|die)|(mem|str)dup)
481 _xa2 = X([CZ]|N?M)ALLOC
482 sc_prohibit_xalloc_without_use:
483 @h='xalloc.h' \
484 re='\<($(_xa1)|$(_xa2)) *\('\
485 $(_sc_header_without_use)
486
487 # Extract function names:
488 # perl -lne '/^(?:extern )?(?:void|char) \*?(\w+) *\(/ and print $1' lib/hash.h
489 _hash_re = \
490 clear|delete|free|get_(first|next)|insert|lookup|print_statistics|reset_tuning
491 _hash_fn = \<($(_hash_re)) *\(
492 _hash_struct = (struct )?\<[Hh]ash_(table|tuning)\>
493 sc_prohibit_hash_without_use:
494 @h='hash.h' \
495 re='$(_hash_fn)|$(_hash_struct)'\
496 $(_sc_header_without_use)
497
498 sc_prohibit_cloexec_without_use:
499 @h='cloexec.h' re='\<(set_cloexec_flag|dup_cloexec) *\(' \
500 $(_sc_header_without_use)
501
502 sc_prohibit_posixver_without_use:
503 @h='posixver.h' re='\<posix2_version *\(' $(_sc_header_without_use)
504
505 sc_prohibit_same_without_use:
506 @h='same.h' re='\<same_name *\(' $(_sc_header_without_use)
507
508 sc_prohibit_hash_pjw_without_use:
509 @h='hash-pjw.h' \
510 re='\<hash_pjw *\(' \
511 $(_sc_header_without_use)
512
513 sc_prohibit_safe_read_without_use:
514 @h='safe-read.h' re='(\<SAFE_READ_ERROR\>|\<safe_read *\()' \
515 $(_sc_header_without_use)
516
517 sc_prohibit_argmatch_without_use:
518 @h='argmatch.h' \
519 re='(\<(ARRAY_CARDINALITY|X?ARGMATCH(|_TO_ARGUMENT|_VERIFY))\>|\<argmatch(_exit_fn|_(in)?valid) *\()' \
520 $(_sc_header_without_use)
521
522 sc_prohibit_canonicalize_without_use:
523 @h='canonicalize.h' \
524 re='CAN_(EXISTING|ALL_BUT_LAST|MISSING)|canonicalize_(mode_t|filename_mode)' \
525 $(_sc_header_without_use)
526
527 sc_prohibit_root_dev_ino_without_use:
528 @h='root-dev-ino.h' \
529 re='(\<ROOT_DEV_INO_(CHECK|WARN)\>|\<get_root_dev_ino *\()' \
530 $(_sc_header_without_use)
531
532 sc_prohibit_openat_without_use:
533 @h='openat.h' \
534 re='\<(openat_(permissive|needs_fchdir|(save|restore)_fail)|l?(stat|ch(own|mod))at|(euid)?accessat)\>' \
535 $(_sc_header_without_use)
536
537 # Prohibit the inclusion of c-ctype.h without an actual use.
538 ctype_re = isalnum|isalpha|isascii|isblank|iscntrl|isdigit|isgraph|islower\
539 |isprint|ispunct|isspace|isupper|isxdigit|tolower|toupper
540 sc_prohibit_c_ctype_without_use:
541 @h='c-ctype.h' re='\<c_($(ctype_re)) *\(' \
542 $(_sc_header_without_use)
543
544 _empty =
545 _sp = $(_empty) $(_empty)
546 # The following list was generated by running:
547 # man signal.h|col -b|perl -ne '/bsd_signal.*;/.../sigwaitinfo.*;/ and print' \
548 # | perl -lne '/^\s+(?:int|void).*?(\w+).*/ and print $1' | fmt
549 _sig_functions = \
550 bsd_signal kill killpg pthread_kill pthread_sigmask raise sigaction \
551 sigaddset sigaltstack sigdelset sigemptyset sigfillset sighold sigignore \
552 siginterrupt sigismember signal sigpause sigpending sigprocmask sigqueue \
553 sigrelse sigset sigsuspend sigtimedwait sigwait sigwaitinfo
554 _sig_function_re = $(subst $(_sp),|,$(strip $(_sig_functions)))
555 # The following were extracted from "man signal.h" manually.
556 _sig_types_and_consts = \
557 MINSIGSTKSZ SA_NOCLDSTOP SA_NOCLDWAIT SA_NODEFER SA_ONSTACK \
558 SA_RESETHAND SA_RESTART SA_SIGINFO SIGEV_NONE SIGEV_SIGNAL \
559 SIGEV_THREAD SIGSTKSZ SIG_BLOCK SIG_SETMASK SIG_UNBLOCK SS_DISABLE \
560 SS_ONSTACK mcontext_t pid_t sig_atomic_t sigevent siginfo_t sigset_t \
561 sigstack sigval stack_t ucontext_t
562 # generated via this:
563 # perl -lne '/^#ifdef (SIG\w+)/ and print $1' lib/sig2str.c|sort -u|fmt -70
564 _sig_names = \
565 SIGABRT SIGALRM SIGALRM1 SIGBUS SIGCANCEL SIGCHLD SIGCLD SIGCONT \
566 SIGDANGER SIGDIL SIGEMT SIGFPE SIGFREEZE SIGGRANT SIGHUP SIGILL \
567 SIGINFO SIGINT SIGIO SIGIOT SIGKAP SIGKILL SIGKILLTHR SIGLOST SIGLWP \
568 SIGMIGRATE SIGMSG SIGPHONE SIGPIPE SIGPOLL SIGPRE SIGPROF SIGPWR \
569 SIGQUIT SIGRETRACT SIGSAK SIGSEGV SIGSOUND SIGSTKFLT SIGSTOP SIGSYS \
570 SIGTERM SIGTHAW SIGTRAP SIGTSTP SIGTTIN SIGTTOU SIGURG SIGUSR1 \
571 SIGUSR2 SIGVIRT SIGVTALRM SIGWAITING SIGWINCH SIGWIND SIGWINDOW \
572 SIGXCPU SIGXFSZ
573 _sig_syms_re = $(subst $(_sp),|,$(strip $(_sig_names) $(_sig_types_and_consts)))
574
575 # Prohibit the inclusion of signal.h without an actual use.
576 sc_prohibit_signal_without_use:
577 @h='signal.h' \
578 re='\<($(_sig_function_re)) *\(|\<($(_sig_syms_re))\>' \
579 $(_sc_header_without_use)
580
581 # Don't include stdio--.h unless you use one of its functions.
582 sc_prohibit_stdio--_without_use:
583 @h='stdio--.h' re='\<((f(re)?|p)open|tmpfile) *\(' \
584 $(_sc_header_without_use)
585
586 # Don't include stdio-safer.h unless you use one of its functions.
587 sc_prohibit_stdio-safer_without_use:
588 @h='stdio-safer.h' re='\<((f(re)?|p)open|tmpfile)_safer *\(' \
589 $(_sc_header_without_use)
590
591 # Prohibit the inclusion of strings.h without a sensible use.
592 # Using the likes of bcmp, bcopy, bzero, index or rindex is not sensible.
593 sc_prohibit_strings_without_use:
594 @h='strings.h' \
595 re='\<(strn?casecmp|ffs(ll)?)\>' \
596 $(_sc_header_without_use)
597
598 # Get the list of symbol names with this:
599 # perl -lne '/^# *define ([A-Z]\w+)\(/ and print $1' lib/intprops.h|fmt
600 _intprops_names = \
601 TYPE_IS_INTEGER TYPE_TWOS_COMPLEMENT TYPE_ONES_COMPLEMENT \
602 TYPE_SIGNED_MAGNITUDE TYPE_SIGNED TYPE_MINIMUM TYPE_MAXIMUM \
603 INT_BITS_STRLEN_BOUND INT_STRLEN_BOUND INT_BUFSIZE_BOUND \
604 INT_ADD_RANGE_OVERFLOW INT_SUBTRACT_RANGE_OVERFLOW \
605 INT_NEGATE_RANGE_OVERFLOW INT_MULTIPLY_RANGE_OVERFLOW \
606 INT_DIVIDE_RANGE_OVERFLOW INT_REMAINDER_RANGE_OVERFLOW \
607 INT_LEFT_SHIFT_RANGE_OVERFLOW INT_ADD_OVERFLOW INT_SUBTRACT_OVERFLOW \
608 INT_NEGATE_OVERFLOW INT_MULTIPLY_OVERFLOW INT_DIVIDE_OVERFLOW \
609 INT_REMAINDER_OVERFLOW INT_LEFT_SHIFT_OVERFLOW
610 _intprops_syms_re = $(subst $(_sp),|,$(strip $(_intprops_names)))
611 # Prohibit the inclusion of intprops.h without an actual use.
612 sc_prohibit_intprops_without_use:
613 @h='intprops.h' \
614 re='\<($(_intprops_syms_re)) *\(' \
615 $(_sc_header_without_use)
616
617 _stddef_syms_re = NULL|offsetof|ptrdiff_t|size_t|wchar_t
618 # Prohibit the inclusion of stddef.h without an actual use.
619 sc_prohibit_stddef_without_use:
620 @h='stddef.h' \
621 re='\<($(_stddef_syms_re)) *\(' \
622 $(_sc_header_without_use)
623
624 # Don't include xfreopen.h unless you use one of its functions.
625 sc_prohibit_xfreopen_without_use:
626 @h='xfreopen.h' re='\<xfreopen *\(' $(_sc_header_without_use)
627
628 sc_obsolete_symbols:
629 @prohibit='\<(HAVE''_FCNTL_H|O''_NDELAY)\>' \
630 halt='do not use HAVE''_FCNTL_H or O'_NDELAY \
631 $(_sc_search_regexp)
632
633 # FIXME: warn about definitions of EXIT_FAILURE, EXIT_SUCCESS, STREQ
634
635 # Each nonempty ChangeLog line must start with a year number, or a TAB.
636 sc_changelog:
637 @prohibit='^[^12 ]' \
638 in_vc_files='^ChangeLog$$' \
639 halt='found unexpected prefix in a ChangeLog' \
640 $(_sc_search_regexp)
641
642 # Ensure that each .c file containing a "main" function also
643 # calls set_program_name.
644 sc_program_name:
645 @require='set_program_name *\(m?argv\[0\]\);' \
646 in_vc_files='\.c$$' \
647 containing='\<main *(' \
648 halt='the above files do not call set_program_name' \
649 $(_sc_search_regexp)
650
651 # Ensure that each .c file containing a "main" function also
652 # calls bindtextdomain.
653 sc_bindtextdomain:
654 @require='bindtextdomain *\(' \
655 in_vc_files='\.c$$' \
656 containing='\<main *(' \
657 halt='the above files do not call bindtextdomain' \
658 $(_sc_search_regexp)
659
660 # Require that the final line of each test-lib.sh-using test be this one:
661 # Exit $fail
662 # Note: this test requires GNU grep's --label= option.
663 Exit_witness_file ?= tests/test-lib.sh
664 Exit_base := $(notdir $(Exit_witness_file))
665 sc_require_test_exit_idiom:
666 @if test -f $(srcdir)/$(Exit_witness_file); then \
667 die=0; \
668 for i in $$(grep -l -F 'srcdir/$(Exit_base)' \
669 $$($(VC_LIST) tests)); do \
670 tail -n1 $$i | grep '^Exit .' > /dev/null \
671 && : || { die=1; echo $$i; } \
672 done; \
673 test $$die = 1 && \
674 { echo 1>&2 '$(ME): the final line in each of the above is not:'; \
675 echo 1>&2 'Exit something'; \
676 exit 1; } || :; \
677 fi
678
679 sc_trailing_blank:
680 @prohibit='[ ]$$' \
681 halt='found trailing blank(s)' \
682 $(_sc_search_regexp)
683
684 # Match lines like the following, but where there is only one space
685 # between the options and the description:
686 # -D, --all-repeated[=delimit-method] print all duplicate lines\n
687 longopt_re = --[a-z][0-9A-Za-z-]*(\[?=[0-9A-Za-z-]*\]?)?
688 sc_two_space_separator_in_usage:
689 @prohibit='^ *(-[A-Za-z],)? $(longopt_re) [^ ].*\\$$' \
690 halt='help2man requires at least two spaces between an option and its description'\
691 $(_sc_search_regexp)
692
693 # A regexp matching function names like "error" that may be used
694 # to emit translatable messages.
695 _gl_translatable_diag_func_re ?= error
696
697 # Look for diagnostics that aren't marked for translation.
698 # This won't find any for which error's format string is on a separate line.
699 sc_unmarked_diagnostics:
700 @grep -nE \
701 '\<$(_gl_translatable_diag_func_re) *\([^"]*"[^"]*[a-z]{3}' \
702 $$($(VC_LIST_EXCEPT)) \
703 | grep -Ev '(_|ngettext ?)\(' && \
704 { echo '$(ME): found unmarked diagnostic(s)' 1>&2; \
705 exit 1; } || :
706
707 # Avoid useless parentheses like those in this example:
708 # #if defined (SYMBOL) || defined (SYM2)
709 sc_useless_cpp_parens:
710 @prohibit='^# *if .*defined *\(' \
711 halt='found useless parentheses in cpp directive' \
712 $(_sc_search_regexp)
713
714 # List headers for which HAVE_HEADER_H is always true, assuming you are
715 # using the appropriate gnulib module. CAUTION: for each "unnecessary"
716 # #if HAVE_HEADER_H that you remove, be sure that your project explicitly
717 # requires the gnulib module that guarantees the usability of that header.
718 gl_assured_headers_ = \
719 cd $(gnulib_dir)/lib && echo *.in.h|sed 's/\.in\.h//g'
720
721 # Convert the list of names to upper case, and replace each space with "|".
722 az_ = abcdefghijklmnopqrstuvwxyz
723 AZ_ = ABCDEFGHIJKLMNOPQRSTUVWXYZ
724 gl_header_upper_case_or_ = \
725 $$($(gl_assured_headers_) \
726 | tr $(az_)/.- $(AZ_)___ \
727 | tr -s ' ' '|' \
728 )
729 sc_prohibit_always_true_header_tests:
730 @or=$(gl_header_upper_case_or_); \
731 re="HAVE_($$or)_H"; \
732 prohibit='\<'"$$re"'\>' \
733 halt=$$(printf '%s\n' \
734 'do not test the above HAVE_<header>_H symbol(s);' \
735 ' with the corresponding gnulib module, they are always true') \
736 $(_sc_search_regexp)
737
738 # ==================================================================
739 gl_other_headers_ ?= \
740 intprops.h \
741 openat.h \
742 stat-macros.h
743
744 # Perl -lne code to extract "significant" cpp-defined symbols from a
745 # gnulib header file, eliminating a few common false-positives.
746 gl_extract_significant_defines_ = \
747 /^\# *define ([^_ (][^ (]*)(\s*\(|\s+\w+)/\
748 && $$2 !~ /(?:rpl_|_used_without_)/\
749 && $$1 !~ /^(?:NSIG|ATTRIBUTE_NORETURN)$$/\
750 and print $$1
751
752 # Create a list of regular expressions matching the names
753 # of macros that are guaranteed to be defined by parts of gnulib.
754 define def_sym_regex
755 gen_h=$(gl_generated_headers_); \
756 (cd $(gnulib_dir)/lib; \
757 for f in *.in.h $(gl_other_headers_); do \
758 perl -lne '$(gl_extract_significant_defines_)' $$f; \
759 done; \
760 ) | sort -u \
761 | grep -Ev '^ATTRIBUTE_NORETURN' \
762 | sed 's/^/^ *# *(define|undef) */;s/$$/\\>/'
763 endef
764
765 # Don't define macros that we already get from gnulib header files.
766 sc_prohibit_always-defined_macros:
767 @if test -d $(gnulib_dir); then \
768 case $$(echo all: | grep -l -f - Makefile) in Makefile);; *) \
769 echo '$(ME): skipping $@: you lack GNU grep' 1>&2; exit 0;; \
770 esac; \
771 $(def_sym_regex) | grep -E -f - $$($(VC_LIST_EXCEPT)) \
772 && { echo '$(ME): define the above via some gnulib .h file' \
773 1>&2; exit 1; } || :; \
774 fi
775 # ==================================================================
776
777 # Prohibit checked in backup files.
778 sc_prohibit_backup_files:
779 @$(VC_LIST) | grep '~$$' && \
780 { echo '$(ME): found version controlled backup file' 1>&2; \
781 exit 1; } || :
782
783 # Require the latest GPL.
784 sc_GPL_version:
785 @prohibit='either ''version [^3]' \
786 halt='GPL vN, N!=3' \
787 $(_sc_search_regexp)
788
789 # Require the latest GFDL. Two regexp, since some .texi files end up
790 # line wrapping between 'Free Documentation License,' and 'Version'.
791 _GFDL_regexp = (Free ''Documentation.*Version 1\.[^3]|Version 1\.[^3] or any)
792 sc_GFDL_version:
793 @prohibit='$(_GFDL_regexp)' \
794 halt='GFDL vN, N!=3' \
795 $(_sc_search_regexp)
796
797 # Don't use Texinfo's @acronym{}.
798 # http://lists.gnu.org/archive/html/bug-gnulib/2010-03/msg00321.html
799 texinfo_suffix_re_ ?= \.(txi|texi(nfo)?)$$
800 sc_texinfo_acronym:
801 @prohibit='@acronym\{' \
802 in_vc_files='$(texinfo_suffix_re_)' \
803 halt='found use of Texinfo @acronym{}' \
804 $(_sc_search_regexp)
805
806 cvs_keywords = \
807 Author|Date|Header|Id|Name|Locker|Log|RCSfile|Revision|Source|State
808
809 sc_prohibit_cvs_keyword:
810 @prohibit='\$$($(cvs_keywords))\$$' \
811 halt='do not use CVS keyword expansion' \
812 $(_sc_search_regexp)
813
814 # This Perl code is slightly obfuscated. Not only is each "$" doubled
815 # because it's in a Makefile, but the $$c's are comments; we cannot
816 # use "#" due to the way the script ends up concatenated onto one line.
817 # It would be much more concise, and would produce better output (including
818 # counts) if written as:
819 # perl -ln -0777 -e '/\n(\n+)$/ and print "$ARGV: ".length $1' ...
820 # but that would be far less efficient, reading the entire contents
821 # of each file, rather than just the last two bytes of each.
822 # In addition, while the code below detects both blank lines and a missing
823 # newline at EOF, the above detects only the former.
824 #
825 # This is a perl script that is expected to be the single-quoted argument
826 # to a command-line "-le". The remaining arguments are file names.
827 # Print the name of each file that ends in exactly one newline byte.
828 # I.e., warn if there are blank lines (2 or more newlines), or if the
829 # last byte is not a newline. However, currently we don't complain
830 # about any file that contains exactly one byte.
831 # Exit nonzero if at least one such file is found, otherwise, exit 0.
832 # Warn about, but otherwise ignore open failure. Ignore seek/read failure.
833 #
834 # Use this if you want to remove trailing empty lines from selected files:
835 # perl -pi -0777 -e 's/\n\n+$/\n/' files...
836 #
837 require_exactly_one_NL_at_EOF_ = \
838 foreach my $$f (@ARGV) \
839 { \
840 open F, "<", $$f or (warn "failed to open $$f: $$!\n"), next; \
841 my $$p = sysseek (F, -2, 2); \
842 my $$c = "seek failure probably means file has < 2 bytes; ignore"; \
843 my $$last_two_bytes; \
844 defined $$p and $$p = sysread F, $$last_two_bytes, 2; \
845 close F; \
846 $$c = "ignore read failure"; \
847 $$p && ($$last_two_bytes eq "\n\n" \
848 || substr ($$last_two_bytes,1) ne "\n") \
849 and (print $$f), $$fail=1; \
850 } \
851 END { exit defined $$fail }
852 sc_prohibit_empty_lines_at_EOF:
853 @perl -le '$(require_exactly_one_NL_at_EOF_)' $$($(VC_LIST_EXCEPT)) \
854 || { echo '$(ME): empty line(s) or no newline at EOF' \
855 1>&2; exit 1; } || :
856
857 # Make sure we don't use st_blocks. Use ST_NBLOCKS instead.
858 # This is a bit of a kludge, since it prevents use of the string
859 # even in comments, but for now it does the job with no false positives.
860 sc_prohibit_stat_st_blocks:
861 @prohibit='[.>]st_blocks' \
862 halt='do not use st_blocks; use ST_NBLOCKS' \
863 $(_sc_search_regexp)
864
865 # Make sure we don't define any S_IS* macros in src/*.c files.
866 # They're already defined via gnulib's sys/stat.h replacement.
867 sc_prohibit_S_IS_definition:
868 @prohibit='^ *# *define *S_IS' \
869 halt='do not define S_IS* macros; include <sys/stat.h>' \
870 $(_sc_search_regexp)
871
872 # Perl block to convert a match to FILE_NAME:LINENO:TEST,
873 # that is shared by two definitions below.
874 perl_filename_lineno_text_ = \
875 -e ' {' \
876 -e ' $$n = ($$` =~ tr/\n/\n/ + 1);' \
877 -e ' ($$v = $$&) =~ s/\n/\\n/g;' \
878 -e ' print "$$ARGV:$$n:$$v\n";' \
879 -e ' }'
880
881 prohibit_doubled_word_RE_ ?= \
882 /\b(then?|[iao]n|i[fst]|but|f?or|at|and|[dt]o)\s+\1\b/gims
883 prohibit_doubled_word_ = \
884 -e 'while ($(prohibit_doubled_word_RE_))' \
885 $(perl_filename_lineno_text_)
886
887 # Define this to a regular expression that matches
888 # any filename:dd:match lines you want to ignore.
889 # The default is to ignore no matches.
890 ignore_doubled_word_match_RE_ ?= ^$$
891
892 sc_prohibit_doubled_word:
893 @perl -n -0777 $(prohibit_doubled_word_) $$($(VC_LIST_EXCEPT)) \
894 | grep -vE '$(ignore_doubled_word_match_RE_)' \
895 | grep . && { echo '$(ME): doubled words' 1>&2; exit 1; } || :
896
897 # A regular expression matching undesirable combinations of words like
898 # "can not"; this matches them even when the two words appear on different
899 # lines, but not when there is an intervening delimiter like "#" or "*".
900 prohibit_undesirable_word_seq_RE_ ?= \
901 /\bcan\s+not\b/gims
902 prohibit_undesirable_word_seq_ = \
903 -e 'while ($(prohibit_undesirable_word_seq_RE_))' \
904 $(perl_filename_lineno_text_)
905 # Define this to a regular expression that matches
906 # any filename:dd:match lines you want to ignore.
907 # The default is to ignore no matches.
908 ignore_undesirable_word_sequence_RE_ ?= ^$$
909
910 sc_prohibit_undesirable_word_seq:
911 @perl -n -0777 $(prohibit_undesirable_word_seq_) \
912 $$($(VC_LIST_EXCEPT)) \
913 | grep -vE '$(ignore_undesirable_word_sequence_RE_)' | grep . \
914 && { echo '$(ME): undesirable word sequence' >&2; exit 1; } || :
915
916 _ptm1 = use "test C1 && test C2", not "test C1 -''a C2"
917 _ptm2 = use "test C1 || test C2", not "test C1 -''o C2"
918 # Using test's -a and -o operators is not portable.
919 # We prefer test over [, since the latter is spelled [[ in configure.ac.
920 sc_prohibit_test_minus_ao:
921 @prohibit='(\<test| \[+) .+ -[ao] ' \
922 halt='$(_ptm1); $(_ptm2)' \
923 $(_sc_search_regexp)
924
925 # Avoid a test bashism.
926 sc_prohibit_test_double_equal:
927 @prohibit='(\<test| \[+) .+ == ' \
928 containing='#! */bin/[a-z]*sh' \
929 halt='use "test x = x", not "test x =''= x"' \
930 $(_sc_search_regexp)
931
932 # Each program that uses proper_name_utf8 must link with one of the
933 # ICONV libraries. Otherwise, some ICONV library must appear in LDADD.
934 # The perl -0777 invocation below extracts the possibly-multi-line
935 # definition of LDADD from the appropriate Makefile.am and exits 0
936 # when it contains "ICONV".
937 sc_proper_name_utf8_requires_ICONV:
938 @progs=$$(grep -l 'proper_name_utf8 ''("' $$($(VC_LIST_EXCEPT)));\
939 if test "x$$progs" != x; then \
940 fail=0; \
941 for p in $$progs; do \
942 dir=$$(dirname "$$p"); \
943 perl -0777 \
944 -ne 'exit !(/^LDADD =(.+?[^\\]\n)/ms && $$1 =~ /ICONV/)' \
945 $$dir/Makefile.am && continue; \
946 base=$$(basename "$$p" .c); \
947 grep "$${base}_LDADD.*ICONV)" $$dir/Makefile.am > /dev/null \
948 || { fail=1; echo 1>&2 "$(ME): $$p uses proper_name_utf8"; }; \
949 done; \
950 test $$fail = 1 && \
951 { echo 1>&2 '$(ME): the above do not link with any ICONV library'; \
952 exit 1; } || :; \
953 fi
954
955 # Warn about "c0nst struct Foo const foo[]",
956 # but not about "char const *const foo" or "#define const const".
957 sc_redundant_const:
958 @prohibit='\bconst\b[[:space:][:alnum:]]{2,}\bconst\b' \
959 halt='redundant "const" in declarations' \
960 $(_sc_search_regexp)
961
962 sc_const_long_option:
963 @grep '^ *static.*struct option ' $$($(VC_LIST_EXCEPT)) \
964 | grep -Ev 'const struct option|struct option const' && { \
965 echo 1>&2 '$(ME): add "const" to the above declarations'; \
966 exit 1; } || :
967
968 NEWS_hash = \
969 $$(sed -n '/^\*.* $(PREV_VERSION_REGEXP) ([0-9-]*)/,$$p' \
970 $(srcdir)/NEWS \
971 | perl -0777 -pe \
972 's/^Copyright.+?Free\sSoftware\sFoundation,\sInc\.\n//ms' \
973 | md5sum - \
974 | sed 's/ .*//')
975
976 # Ensure that we don't accidentally insert an entry into an old NEWS block.
977 sc_immutable_NEWS:
978 @if test -f $(srcdir)/NEWS; then \
979 test "$(NEWS_hash)" = '$(old_NEWS_hash)' && : || \
980 { echo '$(ME): you have modified old NEWS' 1>&2; exit 1; }; \
981 fi
982
983 # Update the hash stored above. Do this after each release and
984 # for any corrections to old entries.
985 update-NEWS-hash: NEWS
986 perl -pi -e 's/^(old_NEWS_hash[ \t]+:?=[ \t]+).*/$${1}'"$(NEWS_hash)/" \
987 $(srcdir)/cfg.mk
988
989 # Ensure that we use only the standard $(VAR) notation,
990 # not @...@ in Makefile.am, now that we can rely on automake
991 # to emit a definition for each substituted variable.
992 # However, there is still one case in which @VAR@ use is not just
993 # legitimate, but actually required: when augmenting an automake-defined
994 # variable with a prefix. For example, gettext uses this:
995 # MAKEINFO = env LANG= LC_MESSAGES= LC_ALL= LANGUAGE= @MAKEINFO@
996 # otherwise, makeinfo would put German or French (current locale)
997 # navigation hints in the otherwise-English documentation.
998 #
999 # Allow the package to add exceptions via a hook in cfg.mk;
1000 # for example, @PRAGMA_SYSTEM_HEADER@ can be permitted by
1001 # setting this to ' && !/PRAGMA_SYSTEM_HEADER/'.
1002 _makefile_at_at_check_exceptions ?=
1003 sc_makefile_at_at_check:
1004 @perl -ne '/\@[A-Z_0-9]+\@/' \
1005 -e ' && !/([A-Z_0-9]+)\s+=.*\@\1\@$$/' \
1006 -e ''$(_makefile_at_at_check_exceptions) \
1007 -e 'and (print "$$ARGV:$$.: $$_"), $$m=1; END {exit !$$m}' \
1008 $$($(VC_LIST_EXCEPT) | grep -E '(^|/)(Makefile\.am|[^/]+\.mk)$$') \
1009 && { echo '$(ME): use $$(...), not @...@' 1>&2; exit 1; } || :
1010
1011 news-check: NEWS
1012 if sed -n $(news-check-lines-spec)p $(srcdir)/NEWS \
1013 | grep -E $(news-check-regexp) >/dev/null; then \
1014 :; \
1015 else \
1016 echo 'NEWS: $$(news-check-regexp) failed to match' 1>&2; \
1017 exit 1; \
1018 fi
1019
1020 sc_makefile_TAB_only_indentation:
1021 @prohibit='^ [ ]{8}' \
1022 in_vc_files='akefile|\.mk$$' \
1023 halt='found TAB-8-space indentation' \
1024 $(_sc_search_regexp)
1025
1026 sc_m4_quote_check:
1027 @prohibit='(AC_DEFINE(_UNQUOTED)?|AC_DEFUN)\([^[]' \
1028 in_vc_files='(^configure\.ac|\.m4)$$' \
1029 halt='quote the first arg to AC_DEF*' \
1030 $(_sc_search_regexp)
1031
1032 fix_po_file_diag = \
1033 'you have changed the set of files with translatable diagnostics;\n\
1034 apply the above patch\n'
1035
1036 # Verify that all source files using _() are listed in po/POTFILES.in.
1037 po_file ?= $(srcdir)/po/POTFILES.in
1038 generated_files ?= $(srcdir)/lib/*.[ch]
1039 sc_po_check:
1040 @if test -f $(po_file); then \
1041 grep -E -v '^(#|$$)' $(po_file) \
1042 | grep -v '^src/false\.c$$' | sort > $@-1; \
1043 files=; \
1044 for file in $$($(VC_LIST_EXCEPT)) $(generated_files); do \
1045 test -r $$file || continue; \
1046 case $$file in \
1047 *.m4|*.mk) continue ;; \
1048 *.?|*.??) ;; \
1049 *) continue;; \
1050 esac; \
1051 case $$file in \
1052 *.[ch]) \
1053 base=`expr " $$file" : ' \(.*\)\..'`; \
1054 { test -f $$base.l || test -f $$base.y; } && continue;; \
1055 esac; \
1056 files="$$files $$file"; \
1057 done; \
1058 grep -E -l '\b(N?_|gettext *)\([^)"]*("|$$)' $$files \
1059 | sed 's|^$(_dot_escaped_srcdir)/||' | sort -u > $@-2; \
1060 diff -u -L $(po_file) -L $(po_file) $@-1 $@-2 \
1061 || { printf '$(ME): '$(fix_po_file_diag) 1>&2; exit 1; }; \
1062 rm -f $@-1 $@-2; \
1063 fi
1064
1065 # Sometimes it is useful to change the PATH environment variable
1066 # in Makefiles. When doing so, it's better not to use the Unix-centric
1067 # path separator of `:', but rather the automake-provided `$(PATH_SEPARATOR)'.
1068 msg = '$(ME): Do not use `:'\'' above; use $$(PATH_SEPARATOR) instead'
1069 sc_makefile_path_separator_check:
1070 @prohibit='PATH[=].*:' \
1071 in_vc_files='akefile|\.mk$$' \
1072 halt=$(msg) \
1073 $(_sc_search_regexp)
1074
1075 # Check that `make alpha' will not fail at the end of the process.
1076 writable-files:
1077 if test -d $(release_archive_dir); then :; else \
1078 for file in $(distdir).tar.gz \
1079 $(release_archive_dir)/$(distdir).tar.gz; do \
1080 test -e $$file || continue; \
1081 test -w $$file \
1082 || { echo ERROR: $$file is not writable; fail=1; }; \
1083 done; \
1084 test "$$fail" && exit 1 || : ; \
1085 fi
1086
1087 v_etc_file = $(gnulib_dir)/lib/version-etc.c
1088 sample-test = tests/sample-test
1089 texi = doc/$(PACKAGE).texi
1090 # Make sure that the copyright date in $(v_etc_file) is up to date.
1091 # Do the same for the $(sample-test) and the main doc/.texi file.
1092 sc_copyright_check:
1093 @require='enum { COPYRIGHT_YEAR = '$$(date +%Y)' };' \
1094 in_files=$(v_etc_file) \
1095 halt='out of date copyright in $(v_etc_file); update it' \
1096 $(_sc_search_regexp)
1097 @require='# Copyright \(C\) '$$(date +%Y)' Free' \
1098 in_vc_files=$(sample-test) \
1099 halt='out of date copyright in $(sample-test); update it' \
1100 $(_sc_search_regexp)
1101 @require='Copyright @copyright\{\} .*'$$(date +%Y)' Free' \
1102 in_vc_files=$(texi) \
1103 halt='out of date copyright in $(texi); update it' \
1104 $(_sc_search_regexp)
1105
1106 # If tests/help-version exists and seems to be new enough, assume that its
1107 # use of init.sh and path_prepend_ is correct, and ensure that every other
1108 # use of init.sh is identical.
1109 # This is useful because help-version cross-checks prog --version
1110 # with $(VERSION), which verifies that its path_prepend_ invocation
1111 # sets PATH correctly. This is an inexpensive way to ensure that
1112 # the other init.sh-using tests also get it right.
1113 _hv_file ?= $(srcdir)/tests/help-version
1114 _hv_regex_weak ?= ^ *\. .*/init\.sh"
1115 # Fix syntax-highlighters "
1116 _hv_regex_strong ?= ^ *\. "\$${srcdir=\.}/init\.sh"
1117 sc_cross_check_PATH_usage_in_tests:
1118 @if test -f $(_hv_file); then \
1119 grep -l 'VERSION mismatch' $(_hv_file) >/dev/null \
1120 || { echo "$@: skipped: no such file: $(_hv_file)" 1>&2; \
1121 exit 0; }; \
1122 grep -lE '$(_hv_regex_strong)' $(_hv_file) >/dev/null \
1123 || { echo "$@: $(_hv_file) lacks conforming use of init.sh" 1>&2; \
1124 exit 1; }; \
1125 good=$$(grep -E '$(_hv_regex_strong)' $(_hv_file)); \
1126 grep -LFx "$$good" \
1127 $$(grep -lE '$(_hv_regex_weak)' $$($(VC_LIST_EXCEPT))) \
1128 | grep . && \
1129 { echo "$(ME): the above files use path_prepend_ inconsistently" \
1130 1>&2; exit 1; } || :; \
1131 fi
1132
1133 # #if HAVE_... will evaluate to false for any non numeric string.
1134 # That would be flagged by using -Wundef, however gnulib currently
1135 # tests many undefined macros, and so we can't enable that option.
1136 # So at least preclude common boolean strings as macro values.
1137 sc_Wundef_boolean:
1138 @prohibit='^#define.*(yes|no|true|false)$$' \
1139 in_files='$(CONFIG_INCLUDE)' \
1140 halt='Use 0 or 1 for macro values' \
1141 $(_sc_search_regexp)
1142
1143 # Even if you use pathmax.h to guarantee that PATH_MAX is defined, it might
1144 # not be constant, or might overflow a stack. In general, use PATH_MAX as
1145 # a limit, not an array or alloca size.
1146 sc_prohibit_path_max_allocation:
1147 @prohibit='(\balloca *\([^)]*|\[[^]]*)PATH_MAX' \
1148 halt='Avoid stack allocations of size PATH_MAX' \
1149 $(_sc_search_regexp)
1150
1151 sc_vulnerable_makefile_CVE-2009-4029:
1152 @prohibit='perm -777 -exec chmod a\+rwx|chmod 777 \$$\(distdir\)' \
1153 in_files=$$(find $(srcdir) -name Makefile.in) \
1154 halt=$$(printf '%s\n' \
1155 'the above files are vulnerable; beware of running' \
1156 ' "make dist*" rules, and upgrade to fixed automake' \
1157 ' see http://bugzilla.redhat.com/542609 for details') \
1158 $(_sc_search_regexp)
1159
1160 vc-diff-check:
1161 (unset CDPATH; cd $(srcdir) && $(VC) diff) > vc-diffs || :
1162 if test -s vc-diffs; then \
1163 cat vc-diffs; \
1164 echo "Some files are locally modified:" 1>&2; \
1165 exit 1; \
1166 else \
1167 rm vc-diffs; \
1168 fi
1169
1170 rel-files = $(DIST_ARCHIVES)
1171
1172 gnulib_dir ?= $(srcdir)/gnulib
1173 gnulib-version = $$(cd $(gnulib_dir) && git describe)
1174 bootstrap-tools ?= autoconf,automake,gnulib
1175
1176 # If it's not already specified, derive the GPG key ID from
1177 # the signed tag we've just applied to mark this release.
1178 gpg_key_ID ?= \
1179 $$(git cat-file tag v$(VERSION) > .ann-sig \
1180 && gpgv .ann-sig - < /dev/null 2>&1 \
1181 | sed -n '/.*key ID \([0-9A-F]*\)/s//\1/p'; rm -f .ann-sig)
1182
1183 translation_project_ ?= coordinator@translationproject.org
1184
1185 # Make info-gnu the default only for a stable release.
1186 ifeq ($(RELEASE_TYPE),stable)
1187 announcement_Cc_ ?= $(translation_project_), $(PACKAGE_BUGREPORT)
1188 announcement_mail_headers_ ?= \
1189 To: info-gnu@gnu.org \
1190 Cc: $(announcement_Cc_) \
1191 Mail-Followup-To: $(PACKAGE_BUGREPORT)
1192 else
1193 announcement_Cc_ ?= $(translation_project_)
1194 announcement_mail_headers_ ?= \
1195 To: $(PACKAGE_BUGREPORT) \
1196 Cc: $(announcement_Cc_)
1197 endif
1198
1199 announcement: NEWS ChangeLog $(rel-files)
1200 @$(build_aux)/announce-gen \
1201 --mail-headers='$(announcement_mail_headers_)' \
1202 --release-type=$(RELEASE_TYPE) \
1203 --package=$(PACKAGE) \
1204 --prev=$(PREV_VERSION) \
1205 --curr=$(VERSION) \
1206 --gpg-key-id=$(gpg_key_ID) \
1207 --news=$(srcdir)/NEWS \
1208 --bootstrap-tools=$(bootstrap-tools) \
1209 --gnulib-version=$(gnulib-version) \
1210 --no-print-checksums \
1211 $(addprefix --url-dir=, $(url_dir_list))
1212
1213 ## ---------------- ##
1214 ## Updating files. ##
1215 ## ---------------- ##
1216
1217 ftp-gnu = ftp://ftp.gnu.org/gnu
1218 www-gnu = http://www.gnu.org
1219
1220 upload_dest_dir_ ?= $(PACKAGE)
1221 emit_upload_commands:
1222 @echo =====================================
1223 @echo =====================================
1224 @echo "$(build_aux)/gnupload $(GNUPLOADFLAGS) \\"
1225 @echo " --to $(gnu_rel_host):$(upload_dest_dir_) \\"
1226 @echo " $(rel-files)"
1227 @echo '# send the ~/announce-$(my_distdir) e-mail'
1228 @echo =====================================
1229 @echo =====================================
1230
1231 define emit-commit-log
1232 printf '%s\n' 'post-release administrivia' '' \
1233 '* NEWS: Add header line for next release.' \
1234 '* .prev-version: Record previous version.' \
1235 '* cfg.mk (old_NEWS_hash): Auto-update.'
1236 endef
1237
1238 .PHONY: no-submodule-changes
1239 no-submodule-changes:
1240 if test -d $(srcdir)/.git; then \
1241 diff=$$(cd $(srcdir) && git submodule -q foreach \
1242 git diff-index --name-only HEAD) \
1243 || exit 1; \
1244 case $$diff in '') ;; \
1245 *) echo '$(ME): submodule files are locally modified:'; \
1246 echo "$$diff"; exit 1;; esac; \
1247 else \
1248 : ; \
1249 fi
1250
1251 submodule-checks ?= no-submodule-changes public-submodule-commit
1252
1253 # Ensure that each sub-module commit we're using is public.
1254 # Without this, it is too easy to tag and release code that
1255 # cannot be built from a fresh clone.
1256 .PHONY: public-submodule-commit
1257 public-submodule-commit:
1258 $(AM_V_GEN)if test -d $(srcdir)/.git; then \
1259 cd $(srcdir) && \
1260 git submodule --quiet foreach test '$$(git rev-parse $$sha1)' \
1261 = '$$(git merge-base origin $$sha1)' \
1262 || { echo '$(ME): found non-public submodule commit' >&2; \
1263 exit 1; }; \
1264 else \
1265 : ; \
1266 fi
1267 # This rule has a high enough utility/cost ratio that it should be a
1268 # dependent of "check" by default. However, some of us do occasionally
1269 # commit a temporary change that deliberately points to a non-public
1270 # submodule commit, and want to be able to use rules like "make check".
1271 # In that case, run e.g., "make check gl_public_submodule_commit="
1272 # to disable this test.
1273 gl_public_submodule_commit ?= public-submodule-commit
1274 check: $(gl_public_submodule_commit)
1275
1276 .PHONY: alpha beta stable
1277 ALL_RECURSIVE_TARGETS += alpha beta stable
1278 alpha beta stable: $(local-check) writable-files $(submodule-checks)
1279 test $@ = stable \
1280 && { echo $(VERSION) | grep -E '^[0-9]+(\.[0-9]+)+$$' \
1281 || { echo "invalid version string: $(VERSION)" 1>&2; exit 1;};}\
1282 || :
1283 $(MAKE) vc-diff-check
1284 $(MAKE) news-check
1285 $(MAKE) distcheck
1286 $(MAKE) dist XZ_OPT=-9ev
1287 $(MAKE) $(release-prep-hook) RELEASE_TYPE=$@
1288 $(MAKE) -s emit_upload_commands RELEASE_TYPE=$@
1289
1290 # Override this in cfg.mk if you follow different procedures.
1291 release-prep-hook ?= release-prep
1292
1293 gl_noteworthy_news_ = * Noteworthy changes in release ?.? (????-??-??) [?]
1294 .PHONY: release-prep
1295 release-prep:
1296 case $$RELEASE_TYPE in alpha|beta|stable) ;; \
1297 *) echo "invalid RELEASE_TYPE: $$RELEASE_TYPE" 1>&2; exit 1;; esac
1298 $(MAKE) --no-print-directory -s announcement > ~/announce-$(my_distdir)
1299 if test -d $(release_archive_dir); then \
1300 ln $(rel-files) $(release_archive_dir); \
1301 chmod a-w $(rel-files); \
1302 fi
1303 echo $(VERSION) > $(prev_version_file)
1304 $(MAKE) update-NEWS-hash
1305 perl -pi -e '$$. == 3 and print "$(gl_noteworthy_news_)\n\n\n"' NEWS
1306 $(emit-commit-log) > .ci-msg
1307 $(VC) commit -F .ci-msg -a
1308 rm .ci-msg
1309
1310 # Override this with e.g., -s $(srcdir)/some_other_name.texi
1311 # if the default $(PACKAGE)-derived name doesn't apply.
1312 gendocs_options_ ?=
1313
1314 .PHONY: web-manual
1315 web-manual:
1316 @test -z "$(manual_title)" \
1317 && { echo define manual_title in cfg.mk 1>&2; exit 1; } || :
1318 @cd '$(srcdir)/doc'; \
1319 $(SHELL) ../build-aux/gendocs.sh $(gendocs_options_) \
1320 -o '$(abs_builddir)/doc/manual' \
1321 --email $(PACKAGE_BUGREPORT) $(PACKAGE) \
1322 "$(PACKAGE_NAME) - $(manual_title)"
1323 @echo " *** Upload the doc/manual directory to web-cvs."
1324
1325 # Code Coverage
1326
1327 init-coverage:
1328 $(MAKE) $(AM_MAKEFLAGS) clean
1329 lcov --directory . --zerocounters
1330
1331 COVERAGE_CCOPTS ?= "-g --coverage"
1332 COVERAGE_OUT ?= doc/coverage
1333
1334 build-coverage:
1335 $(MAKE) $(AM_MAKEFLAGS) CFLAGS=$(COVERAGE_CCOPTS) CXXFLAGS=$(COVERAGE_CCOPTS)
1336 $(MAKE) $(AM_MAKEFLAGS) CFLAGS=$(COVERAGE_CCOPTS) CXXFLAGS=$(COVERAGE_CCOPTS) check
1337 mkdir -p $(COVERAGE_OUT)
1338 lcov --directory . --output-file $(COVERAGE_OUT)/$(PACKAGE).info \
1339 --capture
1340
1341 gen-coverage:
1342 genhtml --output-directory $(COVERAGE_OUT) \
1343 $(COVERAGE_OUT)/$(PACKAGE).info \
1344 --highlight --frames --legend \
1345 --title "$(PACKAGE_NAME)"
1346
1347 coverage: init-coverage build-coverage gen-coverage
1348
1349 # Update gettext files.
1350 PACKAGE ?= $(shell basename $(PWD))
1351 PO_DOMAIN ?= $(PACKAGE)
1352 POURL = http://translationproject.org/latest/$(PO_DOMAIN)/
1353 PODIR ?= po
1354 refresh-po:
1355 rm -f $(PODIR)/*.po && \
1356 echo "$(ME): getting translations into po (please ignore the robots.txt ERROR 404)..." && \
1357 wget --no-verbose --directory-prefix $(PODIR) --no-directories --recursive --level 1 --accept .po --accept .po.1 $(POURL) && \
1358 echo 'en@boldquot' > $(PODIR)/LINGUAS && \
1359 echo 'en@quot' >> $(PODIR)/LINGUAS && \
1360 ls $(PODIR)/*.po | sed 's/\.po//' | sed 's,$(PODIR)/,,' | sort >> $(PODIR)/LINGUAS
1361
1362 # Running indent once is not idempotent, but running it twice is.
1363 INDENT_SOURCES ?= $(C_SOURCES)
1364 .PHONY: indent
1365 indent:
1366 indent $(INDENT_SOURCES)
1367 indent $(INDENT_SOURCES)
1368
1369 # If you want to set UPDATE_COPYRIGHT_* environment variables,
1370 # put the assignments in this variable.
1371 update-copyright-env ?=
1372
1373 # Run this rule once per year (usually early in January)
1374 # to update all FSF copyright year lists in your project.
1375 # If you have an additional project-specific rule,
1376 # add it in cfg.mk along with a line 'update-copyright: prereq'.
1377 # By default, exclude all variants of COPYING; you can also
1378 # add exemptions (such as ChangeLog..* for rotated change logs)
1379 # in the file .x-update-copyright.
1380 .PHONY: update-copyright
1381 update-copyright:
1382 grep -l -w Copyright \
1383 $$(export VC_LIST_EXCEPT_DEFAULT=COPYING && $(VC_LIST_EXCEPT)) \
1384 | $(update-copyright-env) xargs $(build_aux)/$@
1385
1386 # This tight_scope test is skipped with a warning if $(_gl_TS_headers) is not
1387 # overridden and $(_gl_TS_dir)/Makefile.am does not mention noinst_HEADERS.
1388
1389 # NOTE: to override any _gl_TS_* default value, you must
1390 # define the variable(s) using "export" in cfg.mk.
1391 _gl_TS_dir ?= src
1392
1393 ALL_RECURSIVE_TARGETS += sc_tight_scope
1394 sc_tight_scope: tight-scope.mk
1395 @if ! grep '^ *export _gl_TS_headers *=' $(srcdir)/cfg.mk \
1396 > /dev/null \
1397 && ! grep -w noinst_HEADERS $(srcdir)/$(_gl_TS_dir)/Makefile.am \
1398 > /dev/null 2>&1; then \
1399 echo '$(ME): skipping $@'; \
1400 else \
1401 $(MAKE) -s -C $(_gl_TS_dir) \
1402 -f Makefile \
1403 -f $(abs_top_srcdir)/cfg.mk \
1404 -f $(abs_top_builddir)/$< \
1405 _gl_tight_scope \
1406 || fail=1; \
1407 fi
1408 @rm -f $<
1409
1410 tight-scope.mk: $(ME)
1411 @rm -f $@ $@-t
1412 @perl -ne '/^# TS-start/.../^# TS-end/ and print' $(ME) > $@-t
1413 @chmod a=r $@-t && mv $@-t $@
1414
1415 ifeq (a,b)
1416 # TS-start
1417
1418 # Most functions should have static scope.
1419 # Any that don't must be marked with `extern', but `main'
1420 # and `usage' are exceptions: they're always extern, but
1421 # do not need to be marked. Symbols matching `__.*' are
1422 # reserved by the compiler, so are automatically excluded below.
1423 _gl_TS_unmarked_extern_functions ?= main usage
1424 _gl_TS_function_match ?= /^(?:$(_gl_TS_extern)) +.*?(\S+) +\(/
1425
1426 # If your project uses a macro like "XTERN", then put
1427 # the following in cfg.mk to override this default:
1428 # export _gl_TS_extern = extern|XTERN
1429 _gl_TS_extern ?= extern
1430
1431 # The second nm|grep checks for file-scope variables with `extern' scope.
1432 # Without gnulib's progname module, you might put program_name here.
1433 # Symbols matching `__.*' are reserved by the compiler,
1434 # so are automatically excluded below.
1435 _gl_TS_unmarked_extern_vars ?=
1436
1437 # NOTE: the _match variables are perl expressions -- not mere regular
1438 # expressions -- so that you can extend them to match other patterns
1439 # and easily extract matched variable names.
1440 # For example, if your project declares some global variables via
1441 # a macro like this: GLOBAL(type, var_name, initializer), then you
1442 # can override this definition to automatically extract those names:
1443 # export _gl_TS_var_match = \
1444 # /^(?:$(_gl_TS_extern)) .*?\**(\w+)(\[.*?\])?;/ || /\bGLOBAL\(.*?,\s*(.*?),/
1445 _gl_TS_var_match ?= /^(?:$(_gl_TS_extern)) .*?(\w+)(\[.*?\])?;/
1446
1447 # The names of object files in (or relative to) $(_gl_TS_dir).
1448 _gl_TS_obj_files ?= *.$(OBJEXT)
1449
1450 # Files in which to search for the one-line style extern declarations.
1451 # $(_gl_TS_dir)-relative.
1452 _gl_TS_headers ?= $(noinst_HEADERS)
1453
1454 .PHONY: _gl_tight_scope
1455 _gl_tight_scope: $(bin_PROGRAMS)
1456 t=exceptions-$$$$; \
1457 trap 's=$$?; rm -f $$t; exit $$s' 0; \
1458 for sig in 1 2 3 13 15; do \
1459 eval "trap 'v=`expr $$sig + 128`; (exit $$v); exit $$v' $$sig"; \
1460 done; \
1461 src=`for f in $(SOURCES); do \
1462 test -f $$f && d= || d=$(srcdir)/; echo $$d$$f; done`; \
1463 hdr=`for f in $(_gl_TS_headers); do \
1464 test -f $$f && d= || d=$(srcdir)/; echo $$d$$f; done`; \
1465 ( printf '^%s$$\n' '__.*' $(_gl_TS_unmarked_extern_functions); \
1466 grep -h -A1 '^extern .*[^;]$$' $$src \
1467 | grep -vE '^(extern |--)' | sed 's/ .*//'; \
1468 perl -lne \
1469 '$(_gl_TS_function_match) and print "^$$1\$$"' $$hdr; \
1470 ) | sort -u > $$t; \
1471 nm -e $(_gl_TS_obj_files) | sed -n 's/.* T //p'|grep -Ev -f $$t \
1472 && { echo the above functions should have static scope >&2; \
1473 exit 1; } || : ; \
1474 ( printf '^%s$$\n' '__.*' $(_gl_TS_unmarked_extern_vars); \
1475 perl -lne '$(_gl_TS_var_match) and print "^$$1\$$"' $$hdr *.h \
1476 ) | sort -u > $$t; \
1477 nm -e $(_gl_TS_obj_files) | sed -n 's/.* [BCDGRS] //p' \
1478 | sort -u | grep -Ev -f $$t \
1479 && { echo the above variables should have static scope >&2; \
1480 exit 1; } || :
1481 # TS-end
1482 endif